//
//  Copyright (c) 2004 Nat!
//  All rights reserved.
//
//  A Mulle kybernetiK production
//  www.mulle-kybernetik.com
//
#import "HostPingList.h"
#import "HostPingStatus.h"


@implementation HostPingList

- (id) init
{
   [super init];
 
   array_ = [[NSMutableArray alloc] init];
      
   return( self);
}


- (void) dealloc
{
   [array_ release];
   
   [super dealloc];
}


- (void) addHost:(NSHost *) host
{
   id   ping;
   
   NSParameterAssert( host);

   ping = [[HostPingStatus alloc] initWithHost:host];
   [array_ addObject:ping];
   [ping release];
}


- (unsigned int) _hostIndex:(NSHost *) host
{
   unsigned int     i, n;
   HostPingStatus   *p;
   
   n = [array_ count];
   for( i = 0; i < n; i++)
   {
      p = [array_ objectAtIndex:i];
      if( [[p host] isEqual:host])
         return( i);
   }
   return( NSNotFound);
}


- (void) removeHost:(NSHost *) host
{
   unsigned int   i;

   NSParameterAssert( host);
   i = [self _hostIndex:host];
   if( i != NSNotFound)
   {
      [array_ removeObjectAtIndex:i];
      return;
   }
   
   NSLog( @"Host %@ not found", host);
}


- (BOOL) isUp:(NSHost *) host
{
   unsigned int  i;
   
   NSParameterAssert( host);
   i = [self _hostIndex:host];
   if( i == NSNotFound)
      return( NO);
/*      [NSException raise:NSGenericException
                  format:@"Host %@ unknown, should be added with addHost:", host];
  */ 
   return( [[array_ objectAtIndex:i] isUp]);
}


- (BOOL) isUpAtIndex:(unsigned int) index
{
   return( [[array_ objectAtIndex:index] isUp]);
}


- (NSHost *) hostAtIndex:(unsigned int) index
{
   return( [(HostPingStatus *) [array_ objectAtIndex:index] host]);
}


- (void) updateAsynchronously
{
   unsigned int  i, n;
   
   n = [array_ count];
   for( i = 0; i < n; i++)
      [[array_ objectAtIndex:i] updateAsynchronously];
}


- (void) update
{
   unsigned int  i, n;
   
   n = [array_ count];
   for( i = 0; i < n; i++)
      [[array_ objectAtIndex:i] ping];
}


- (void) updateWithList:(HostPingList *) other
{
   unsigned int     i, n;
   HostPingStatus   *ping;
   
   if( other)
   {
      n = [array_ count];
      for( i = 0; i < n; i++)
      {
         ping = [array_ objectAtIndex:i];
         if( [other isUp:[ping host]])   // if down keep it at "Unknown"
            [ping setIsUp:YES];
      }
   }
}


- (unsigned int) count
{
   return( [array_ count]);
}


@end
